""" Copyright start
  Copyright (C) 2008 - 2020 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end """
from django.db import models

from workflow.enums import StepStatus, WorkflowStatus


class WorkflowQuerySet(models.QuerySet):
    def paused(self):
        return self.filter(status=WorkflowStatus.paused.value)


class WorkflowStepQuerySet(models.QuerySet):
    def initial(self):
        return self.filter(initial=True)

    def active(self):
        return self.filter(status=StepStatus.active.value)

    def awaiting(self):
        return self.filter(status=StepStatus.awaiting.value)

    def finished(self):
        return self.filter(status=StepStatus.finished.value)

    def failed(self):
        return self.filter(status=StepStatus.failed.value)

    def skipped(self):
        return self.filter(status=StepStatus.skipped.value)

    def finished_with_error(self):
        return self.filter(status=StepStatus.finished_with_error.value)
